Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/XASessionImpl.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/XASessionImpl.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/XASessionImpl.java	(revision )
@@ -19,7 +19,12 @@
 import org.apache.jackrabbit.api.XASession;
 import org.apache.jackrabbit.core.config.WorkspaceConfig;
 import org.apache.jackrabbit.core.lock.XALockManager;
+import org.apache.jackrabbit.core.observation.EventStateCollectionFactory;
 import org.apache.jackrabbit.core.security.authentication.AuthContext;
+import org.apache.jackrabbit.core.session.SessionContext;
+import org.apache.jackrabbit.core.state.ItemStateCacheFactory;
+import org.apache.jackrabbit.core.state.LocalItemStateManager;
+import org.apache.jackrabbit.core.state.SharedItemStateManager;
 import org.apache.jackrabbit.core.state.XAItemStateManager;
 import org.apache.jackrabbit.core.version.InternalVersionManager;
 import org.apache.jackrabbit.core.version.InternalXAVersionManager;
@@ -410,5 +415,10 @@
         } else {
             return s1.equals(s2);
         }
+    }
+
+    @Override
+    public LocalItemStateManager createItemStateManager(RepositoryContext repositoryContext, WorkspaceImpl workspace, SharedItemStateManager sharedStateMgr, EventStateCollectionFactory factory, String attributeName, ItemStateCacheFactory cacheFactory) {
+            return XAItemStateManager.createInstance(sharedStateMgr, factory, attributeName, cacheFactory);
     }
 }
Index: jackrabbit-spi-commons/src/main/java/org/apache/jackrabbit/spi/commons/name/AbstractPath.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-spi-commons/src/main/java/org/apache/jackrabbit/spi/commons/name/AbstractPath.java	(revision 1748387)
+++ jackrabbit-spi-commons/src/main/java/org/apache/jackrabbit/spi/commons/name/AbstractPath.java	(revision )
@@ -133,7 +133,9 @@
     }
 
     public final Path resolve(Element element) {
-        if (element.denotesName()) {
+        if (element.denotesName() && element.denotesIdentifier()) {
+            return new CargoNamePath(this, element.getName(), element.getIdentifier());
+        } else if (element.denotesName()) {
             return new NamePath(this, element.getName(), element.getIndex());
         } else if (element.denotesParent()) {
             if (isAbsolute() && getDepth() == 0) {
@@ -164,6 +166,8 @@
             return new CurrentPath(this);
         } else if (relative.denotesParent()) {
             return new ParentPath(this);
+        } else if (relative.denotesIdentifier() && relative.denotesName()) {
+            return new CargoNamePath(this, relative.getName(), relative.getIdentifier());
         } else if (relative.denotesName()) {
             return new NamePath(this, relative.getName(), relative.getIndex());
         } else {
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/journal/DatabaseJournal.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/journal/DatabaseJournal.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/journal/DatabaseJournal.java	(revision )
@@ -415,25 +415,15 @@
      * {@inheritDoc}
      */
     public RecordIterator getRecords(long startRevision) throws JournalException {
-        try {
-            return new DatabaseRecordIterator(conHelper.exec(selectRevisionsStmtSQL, new Object[]{new Long(
-                    startRevision)}, false, 0), getResolver(), getNamePathResolver());
-        } catch (SQLException e) {
-            throw new JournalException("Unable to return record iterator.", e);
+        return new DatabaseRecordIterator(conHelper, selectRevisionsStmtSQL, startRevision, getResolver(), getNamePathResolver());
-        }
+    }
-    }
 
     /**
      * {@inheritDoc}
      */
     public RecordIterator getRecords() throws JournalException {
-        try {
-            return new DatabaseRecordIterator(conHelper.exec(selectRevisionsStmtSQL, new Object[]{new Long(
-                    Long.MIN_VALUE)}, false, 0), getResolver(), getNamePathResolver());
-        } catch (SQLException e) {
-            throw new JournalException("Unable to return record iterator.", e);
+        return new DatabaseRecordIterator(conHelper, selectRevisionsStmtSQL, Long.MIN_VALUE, getResolver(), getNamePathResolver());
-        }
+    }
-    }
 
     /**
      * Synchronize contents from journal. May be overridden by subclasses.
@@ -800,6 +790,13 @@
 
                 // Insert the given revision in the database
                 if (!exists) {
+                    if (revision == 0l) {
+                        // cluster node is new, start revision is current journal head
+                        rs = conHelper.exec(selectGlobalStmtSQL, null, false, 0);
+                        if (rs.next()) {
+                            revision = rs.getLong(1);
+                        }
+                    }
                     conHelper.exec(insertLocalRevisionStmtSQL, revision, getId());
                 }
 
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/persistence/util/NodePropBundle.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/persistence/util/NodePropBundle.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/persistence/util/NodePropBundle.java	(revision )
@@ -306,7 +306,6 @@
      */
     public void addProperty(PropertyEntry entry) {
         assert !NameConstants.JCR_PRIMARYTYPE.equals(entry.getName());
-        assert !NameConstants.JCR_MIXINTYPES.equals(entry.getName());
         assert !NameConstants.JCR_UUID.equals(entry.getName());
         properties.put(entry.getName(), entry);
     }
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/WorkspaceImpl.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/WorkspaceImpl.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/WorkspaceImpl.java	(revision )
@@ -895,15 +895,7 @@
         SharedItemStateManager sism = getSharedItemStateManager();
         ItemStateCacheFactory iscf =
             context.getRepositoryContext().getItemStateCacheFactory();
-
-        // FIXME We should be able to avoid the instanceof operator here
-        if (context.getSessionImpl() instanceof XASessionImpl) {
-            return XAItemStateManager.createInstance(
-                    sism, this, null, iscf);
-        } else {
-            return LocalItemStateManager.createInstance(
-                    sism, this, iscf);
-        }
+        return context.getSessionImpl().createItemStateManager(this.context.getRepositoryContext(), this, sism, this, null, iscf);
 
     }
 
Index: jackrabbit-core/src/main/java/org/apache/jackrabbit/core/persistence/pool/BundleDbPersistenceManager.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- jackrabbit-core/src/main/java/org/apache/jackrabbit/core/persistence/pool/BundleDbPersistenceManager.java	(revision 1748387)
+++ jackrabbit-core/src/main/java/org/apache/jackrabbit/core/persistence/pool/BundleDbPersistenceManager.java	(revision )
@@ -152,6 +152,7 @@
     protected String nodeReferenceUpdateSQL;
     protected String nodeReferenceSelectSQL;
     protected String nodeReferenceDeleteSQL;
+    protected String nodeReferenceSelectAllSQL;
 
     /** file system where BLOB data is stored */
     protected CloseableBLOBStore blobStore;
@@ -1016,6 +1017,41 @@
         }
     }
 
+    public synchronized List<NodeReferences> getAllNodeReference() throws ItemStateException {
+        if (!initialized) {
+            throw new IllegalStateException("not initialized");
+        }
+        List<NodeReferences> result = new ArrayList<NodeReferences>();
+        ResultSet rs = null;
+        InputStream in = null;
+        try {
+            rs = conHelper.exec(nodeReferenceSelectAllSQL, new Object[] {}, false, 0);
+            while (rs.next()) {
+                NodeId nodeId;
+                if (getStorageModel() == SM_BINARY_KEYS) {
+                    nodeId = new NodeId(rs.getBytes(1));
+                } else {
+                    long high = rs.getLong(1);
+                    long low = rs.getLong(2);
+                    nodeId = new NodeId(high, low);
+                }
+                NodeReferences refs = new NodeReferences(nodeId);
+                in = rs.getBinaryStream(getStorageModel() == SM_BINARY_KEYS ? 2 : 3);
+                Serializer.deserialize(refs, in);
+                result.add(refs);
+                IOUtils.closeQuietly(in);
+            }
+        } catch (Exception e) {
+            String msg = "failed to read references";
+            log.error(msg, e);
+            throw new ItemStateException(msg, e);
+        } finally {
+            IOUtils.closeQuietly(in);
+            DbUtility.close(rs);
+        }
+        return result;
+    }
+
     /**
      * {@inheritDoc}
      *
@@ -1108,6 +1144,7 @@
      */
     protected void buildSQLStatements() {
         // prepare statements
+        nodeReferenceSelectAllSQL = "select * from " + schemaObjectPrefix + "REFS";
         if (getStorageModel() == SM_BINARY_KEYS) {
             bundleInsertSQL = "insert into " + schemaObjectPrefix + "BUNDLE (BUNDLE_DATA, NODE_ID) values (?, ?)";
             bundleUpdateSQL = "update " + schemaObjectPrefix + "BUNDLE set BUNDLE_DATA = ? where NODE_ID = ?";
